import { SES } from 'aws-sdk';
//
const nodemailer = require("nodemailer");
const path = require("path");
const AWS = require('aws-sdk');
const Email = require('email-templates');
//
import Utils from "./../API/IKUtils";
//
export default class IKMailer {
  constructor(_defaultFrom, region) {
    this.from = _defaultFrom;
    //setup local stuff
    let configObj = {region: region};
    if (Utils.isOffline()) configObj = {region: region, accessKeyId: process.env.AWS_ACCESS_KEY_ID, secretAccessKey: process.env.AWS_SECRET_ACCESS_KEY};
    AWS.config.update(configObj);
    //
    this.transporter = nodemailer.createTransport({
      SES: new AWS.SES({ apiVersion: "2010-12-01" })
    });
  }

  //to can be an array or just one address
  async sendTemplatedEmail(_to, _template, _data) {
    const email = new Email({
      //locals: {cache: false},
      message: {from: this.from, to: _to},
      transport: this.transporter,
      send: true
    });
    let resp = null;
    try {
      resp = await email.send({template: (_template ? _template : 'raw'), locals: _data});
      console.debug('Mailer resp:', resp);
    } catch (e) { console.err('Mailer error:', e); }
    return resp;
  }
}
